//
// Copyright (c) 2009 Froduald Kabanza and the Université de Sherbrooke.
// Use of this software is permitted for non-commercial research purposes, and
// it may be copied or applied only for that use. All copies must include this
// copyright message.
// 
// This is a research prototype that has not gone through intensive tests and
// is delivered as is. It may still contain bugs. Froduald Kabanza and the
// Université de Sherbrooke disclaim any responsibility for damage that may be
// caused by using it.
//
// Please note that some files were inspired in part by the PDDL4J library:
// http://www.math-info.univ-paris5.fr/~pellier/software/software.php 
//
// Implementation: Simon Chamberland
// Project Manager: Froduald Kabanza
//

#ifndef _SOMETIME_AFTER_H
#define _SOMETIME_AFTER_H

#include "AlwaysExp.h"
#include "SometimeExp.h"
#include "Composite/TemporalImplyExp.h"

namespace planning
{
  /// <summary>
  /// Represents a constraint expression which must be evaluated at the end of the trajectory.
  /// </summary>
  class SometimeAfterExp : public AlwaysExp
  {
  public:
    SometimeAfterExp(const ITemporalExp* exp, const ITemporalExp* afterExp)
      : AlwaysExp(new TemporalImplyExp(m_exp, new SometimeExp(m_afterExp))), m_exp(exp), m_afterExp(afterExp)
    {
      assert(m_exp != NULL);
      assert(m_afterExp != NULL);

      m_exp->acquire(this);
      m_afterExp->acquire(this);

      INITIALIZE_HASH_CODE();
    }

    ~SometimeAfterExp()
    {
      m_exp->release(this);
      m_afterExp->release(this);
    }

  protected:
    virtual void _output(std::ostream& out) const;

    virtual size_t _calculateHashCode() const
    {
      return 11 * m_exp->getHashCode()
           + 13 * m_afterExp->getHashCode()
           + 9377;
    }

    virtual const IExp* _internalApply(const Bindings* bindings) const;

    virtual int _internalCompareTo(const IExp& other) const;

  private:
    const ITemporalExp* m_exp;
    const ITemporalExp* m_afterExp;
  };
}

#endif